openapi: 3.0.0
info:
  version: 1.0.0
  title: Kalimasi User API
  description: "提供給通用能源監控系統的API，做為"

servers:
# Added by API Auto Mocking Plugin
  - description: SwaggerHub API Auto Mocking
    url: https://virtserver.swaggerhub.com/pet94/ZAPI-User/1.0.0

tags:
  - name: auth
    description: 身份驗證相關API
  - name: budget
    description: 預算API
  - name: receipt
    description: 收據發票API
  - name: rebate
    description: 折讓憑證API
  - name: account
    description: 帳務API
  - name: accTerm
    description: 會計科目API
  - name: transfer
    description: 轉帳API
  - name: report
    description: 報表API
  - name: member
    description: 會員API   
  - name: company
    description: 公司API 
paths:
  /v1/login:
    post:
      tags: [auth]
      summary: 登入
      operationId: login
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Login'
      responses:
        '200':
          description: ok
          content:
            application/json:
              schema:
                type: object
                properties:
                  token:
                    type: string
                  permission:
                    type: string
                  payMethod:
                    type: array
                    items:
                      type: object
                      properties:
                        name:
                          type: string
                        display:
                          type: string
                  incomes:
                    type: array
                    items:
                      type: object
                      properties:
                        name:
                          type: string
                        display:
                          type: string
        '401':
          description: 無效的firebase token
  /v1/app:
    get:
      tags: [auth]
      summary: 檢查app版本
      operationId: get-app
      parameters:
        - in: query
          name: p
          required: true
          schema:
            type: string
            enum: ["vb"]
          description: platform
      responses:
        '200':
          description: ok
        '403':
          description: 禁止使用
  /v1/user/company:
    get:
      tags: [auth]
      summary: 取得使用者公司列表
      operationId: get-user-company
      security:
        - ApiKeyAuth: []
      responses:
        '200':
          description: ok
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetUserCompany'
        '403':
          description: 禁止使用
  /v1/accTerm:
    get:
      tags: [accTerm]
      summary: 取得會計科目
      operationId: get-accTerm
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: t
          required: true
          schema:
            type: string
            enum: ["assets","debt","fund","income","expenses"]
          description: 類型
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetAccTermList'
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/budget:
    get:
      tags: [budget]
      summary: 取得預算清單
      operationId: get-budget
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: year
          required: false
          schema:
            type: integer
          description: 年度
        - in: query
          name: title
          required: false
          schema:
            type: string
          description: 抬頭
        - in: query
          name: type
          required: false
          schema:
            type: string
            enum: [project, year]
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetBudget'
        '204':
          description: no content
        '400':
          description: bad request
        '500':
          description: internal server error
    post:
      tags: [budget]
      summary: 建立預算(年度/專案)
      operationId: post-budget
      security:
        - ApiKeyAuth: []
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PostBudget'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/budget/{ID}:
    get:
      tags: [budget]
      summary: 預算詳細
      operationId: get-budget-detail
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: budgetID
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BudgetDetail'
        '404':
          description: not found
        '400':
          description: bad request
        '500':
          description: internal server error
    put:
      tags: [budget]
      summary: 修改預算
      operationId: pub-budget
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: budgetID
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ModifyBudget'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
    delete:
      tags: [budget]
      summary: 刪除預算
      operationId: delete-budget
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: budgetID
      responses:
        '200':
          description: OK
        '404':
          description: 找不到預算
        '500':
          description: internal server error
  /v1/receipt:
    post:
      tags: [receipt]
      summary: 建立收據
      operationId: create-receipt
      security:
        - ApiKeyAuth: []
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PostReceipt'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
    get:
      tags: [receipt]
      summary: 收據清單
      operationId: get-receipt
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: at
          required: false
          schema:
            type: string
            enum: ["income","expenses"]
          description: 類型 (收入,支出)
        - in: query
          name: t
          required: false
          schema:
            type: string
            enum: ["electronic","triplicate","duplicate","invoice"]
          description: 發票類型 (電子,三聯,二聯,憑證)
        - in: query
          name: number
          required: false
          schema:
            type: string
          description: 發票號碼
        - in: query
          name: budget
          required: false
          schema:
            type: string
          description: 預算/專案ID
        - in: query
          name: sd
          required: false
          schema:
            type: string
          description: 起始日期
        - in: query
          name: ed
          required: false
          schema:
            type: string
          description: 結束日期
        - in: query
          name: page
          required: false
          schema:
            type: integer
          description: 頁數
        - in: query
          name: limit
          required: false
          schema:
            type: integer
          description: 筆數
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetReceiptPagination'
        '204':
          description: no content
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/receipt/{ID}:
    get:
      tags: [receipt]
      summary: 預算發票
      operationId: get-receipt-detail
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: 發票ID
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ReceiptDetail'
        '404':
          description: not found
        '400':
          description: bad request
        '500':
          description: internal server error
    put:
      tags: [receipt]
      summary: 修改發票
      operationId: pub-receipt
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: receiptID
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PutReceiptDetail'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
    delete:
      tags: [receipt]
      summary: 刪除發票
      operationId: delete-receipt
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: 發票ID
      responses:
        '200':
          description: OK
        '404':
          description: 找不到發票
        '500':
          description: internal server error
  /v1/rebate:
    post:
      tags: [rebate]
      summary: 建立折讓資料
      operationId: create-rebate
      security:
        - ApiKeyAuth: []
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PostRebate'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error 
    get:
      tags: [rebate]
      summary: 折讓清單
      operationId: get-rebate
      security:
        - ApiKeyAuth: []
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetRebatePagination'
        '204':
          description: no content
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/rebate/{ID}:
    get:
      tags: [rebate]
      summary: 取得折讓明細
      operationId: get-rebate-detail
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: rebateID
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetRebateDetail'
        '204':
          description: no content
        '400':
          description: bad request
        '500':
          description: internal server error
    put:
      tags: [rebate]
      summary: 更新折讓
      operationId: put-rebate-detail
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: rebateID
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PutRebate'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
    delete:
      tags: [rebate]
      summary: 刪除折讓
      operationId: delete-rebate
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: 折讓ID
      responses:
        '200':
          description: OK
        '404':
          description: 找不到折讓資料
        '500':
          description: internal server error
  /v1/transfer:
    post:
      tags: [transfer]
      summary: 建立轉帳資料
      operationId: create-transfer
      security:
        - ApiKeyAuth: []
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PostTransfer'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
    get:
      tags: [transfer]
      summary: 轉帳清單
      operationId: get-transfer
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: s
          required: false
          schema:
            type: string
          description: 摘要關鍵字
        - in: query
          name: sd
          required: false
          schema:
            type: string
          description: 日期
        - in: query
          name: budget
          required: false
          schema:
            type: string
          description: 預算Id
        - in: query
          name: page
          required: false
          schema:
            type: integer
          description: 頁數
        - in: query
          name: limit
          required: false
          schema:
            type: integer
          description: 筆數
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetTransferPagination'
        '204':
          description: no content
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/transfer/{ID}:
    get:
      tags: [transfer]
      summary: 轉帳明細資料
      operationId: get-trnasfer-detail
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: transferID
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransferDetail'
        '404':
          description: not found
        '400':
          description: bad request
        '500':
          description: internal server error
    put:
      tags: [transfer]
      summary: 修改轉資
      operationId: put-transfer
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: transferID
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PutTransfer'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
    delete:
      tags: [transfer]
      summary: 刪除發票
      operationId: delete-transfer
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: 轉帳ID
      responses:
        '200':
          description: OK
        '404':
          description: 找不到發票
        '500':
          description: internal server error
  /v1/report/budget:
    get:
      tags: [report]
      summary: 收支預算表
      operationId: get-budget-report
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: current
          required: true
          schema:
            type: string
          description: 目前的預算表
        - in: query
          name: last
          required: true
          schema:
            type: string
          description: 比對的預算
        - in: query
          name: f
          required: true
          schema:
            type: string
            enum: ["json", "pdf"]
          description: 格式
      responses:
        '301':
          description: redirect
          headers:
            Location:
              schema:
                type: "string"
              description: 報表URL
        '404':
          description: not found
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/report/finalAccount:
    get:
      tags: [report]
      summary: 收支決算表
      operationId: get-final-account-report
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: budget
          required: true
          schema:
            type: string
          description: 年度預算表
        - in: query
          name: f
          required: true
          schema:
            type: string
            enum: ["json", "pdf"]
          description: 格式
      responses:
        '301':
          description: OK
          headers:
            Location:
              schema:
                type: "string"
              description: 報表URL
        '404':
          description: not found
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/report/balanceSheet:
    get:
      tags: [report]
      summary: 資產負債表
      operationId: get-balance-sheet
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: year
          required: true
          schema:
            type: string
          description: 年度
        - in: query
          name: f
          required: true
          schema:
            type: string
            enum: ["json", "pdf"]
          description: 格式
      responses:
        '301':
          description: OK
          headers:
            Location:
              schema:
                type: "string"
              description: 報表URL
        '404':
          description: not found
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/report/enterIncome:
    get:
      tags: [report]
      summary: 營業進銷項格式
      operationId: get-enter-income
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: sd
          required: true
          schema:
            type: string
          description: 起始日期
        - in: query
          name: ed
          required: true
          schema:
            type: string
          description: 結束日期
      responses:
        '301':
          description: OK
          headers:
            Location:
              schema:
                type: "string"
              description: 檔案URL
        '404':
          description: not found
        '400':
          description: bad request
        '500':
          description: internal server error

  /v1/member:
    post:
      tags: [member]
      summary: 建立會員資料
      operationId: create-member
      security:
        - ApiKeyAuth: []
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Postmember'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
    get:
      tags: [member]
      summary: 取得會員清單
      operationId: get-member-list
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: n
          required: true
          schema:
            type: string
          description: 姓名
        - in: query
          name: m
          required: true
          schema:
            type: string
          description: Email
        - in: query
          name: p
          required: true
          schema:
            type: string
          description: 電話
        - in: query
          name: page
          required: false
          schema:
            type: integer
          description: 頁數
        - in: query
          name: limit
          required: false
          schema:
            type: integer
          description: 筆數
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MemberPaginator'
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/member/{ID}:
    get:
      tags: [member]
      summary: 取得會員明細
      operationId: get-member-detail
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: memberID
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MemberDetail'
        '400':
          description: bad request
        '500':
          description: internal server error
    put:
      tags: [member]
      summary: 更新會員明細
      operationId: modify-member
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: memberID
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Modifymember'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/member/{ID}/payment:
    post:
      tags: [member]
      summary: 建立會員付款紀錄
      operationId: post-member-payment
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: memberID
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateMemberPayment'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '500':
          description: internal server error
  /v1/member/payment/{ID}:
    delete:
      tags: [member]
      summary: 刪除付款紀錄
      operationId: delete-member-payment
      security:
        - ApiKeyAuth: []
      parameters:
        - in: path
          name: ID
          required: true
          schema:
            type: string
          description: paymentID
      responses:
        '200':
          description: OK
        '404':
          description: 找不到付款資料
        '500':
          description: internal server error
  /v1/report/taxCal:
    post:
      tags: [report]
      summary: 存儲餘絀表
      operationId: create_tax_calculate_report
      security:
        - ApiKeyAuth: []
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AccountCalReport'
      responses:
        '200':
          description: OK
        '400':
          description: bad request
        '403':
          description: forbidden (已鎖定無法更新) 
        '500':
          description: internal server error
    get:
      tags: [report]
      summary: 取得餘絀報表
      operationId: get_tax_calculate_report
      security:
        - ApiKeyAuth: []
      parameters:
        - in: query
          name: year
          required: true
          schema:
            type: integer
          description: 年度
        - in: query
          name: act
          required: false
          schema:
            type: boolean
          description: 是否更新
        - in: query
          name: f
          schema:
            type: string
            enum: ["json","pdf"]
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AccountCalReport'
        '301':
          description: OK
          headers:
            Location:
              schema:
                type: "string"
              description: 報表URL
        '404':
          description: 找不到付款資料
        '500':
          description: internal server error
  /v1/company/conf:
    get:
      tags: [company]
      summary: 取得公司設定
      operationId: get-company-conf
      parameters:
        - in: query
          name: usage
          required: false
          schema:
            type: string
            enum: ["edit", "other"]
          description: 用途 (編輯模式會多disable的資料)
          
      responses:
        '200':
          description: ok
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CompanyConf'
        '404':
          description: 找不到公司
        '500':
          description: internal server error
components:
  schemas:
    CompanyConf:
      type: object
      properties:
        payMethod:
          type: array
          items:
            type: object
            properties:
              name:
                type: string
              display:
                type: string
              enable:
                type: boolean
              accTermCode:
                type: string
        incomes:
          type: array
          items:
            type: object
            properties:
              name:
                type: string
              display:
                type: string
              enable:
                type: boolean
              accTermCode:
                type: string
    GetUserCompany:
      type: array
      items:
        type: object
        properties:
          id:
            type: string
          name:
            type: string
          unitCode:
            type: string
          isFake:
            type: boolean
    AccountCalItem:
      type: object
      properties:
        name:
          type: string
        desc:
          type: string
        amount:
          type: integer
        adjust:
          type: integer
        ps:
          type: string
    AccountCalReport:
      type: object
      properties:
        year:
          type: integer
        companyName:
          type: string
        startTime:
          type: string
        endTime:
          type: string
        unitCode:
          type: string
        incomes:
          type: array
          items:
            $ref: '#/components/schemas/AccountCalItem'
        expenses:
          type: array
          items:
            $ref: '#/components/schemas/AccountCalItem'
        isTaxFree:
          type: boolean
          description: 是否適用免稅
        taxFreeAmount:
          type: integer
          description: 免稅額
        openMonth:
          type: integer
          description: 營業月數(預設12月)
        taxCredit:
          type: integer
          description: 扣抵稅額
        overseasTaxCredit:
          type: integer
          description: 海外扣抵稅額
        lostInvoice:
          type: integer
          description: 丟失憑證總額
    CreateMemberPayment:
      type: object
      properties:
        payDate:
          type: string
        payType:
          type: string
          enum: ["annualFee", "jobDonation", "donation"]
          description: 付款類別
        amount:
          type: integer
          description: 金額
        method:
          type: string
          description: 付款方式
        desc:
          type: string
          description: 摘要
    MemberDetail:
      type: object
      properties:
        id:
          type: string
        mType:
          type: string
        mid:
          type: string
          description: 身份證字號 (統一編號)
        name:
          type: string
          description: 名字 (公司名稱)
        sex:
          type: integer
          enum: [0,1]
          description: 性別
        birthday:
          type: string
        email:
          type: string
        address:
          type: string
        serviceUnit:
          type: string
          description: 服務單位
        contact:
          type: array
          items:
            type: object
            properties:
              ctType:
                type: string
                enum: ["home", "office", "mobile"]
              value:
                type: string
        payRecord:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                description: 付款id
              payDate:
                type: string
                description: 繳費日期
              fee:
                type: string
                description: 付款類型
              displayFee:
                type: string
                description: 付款名稱
              displayMethod:
                type: string
              method:
                type: string
              amount:
                type: string
              desc:
                type: string
                description: 說明
    MemberPaginator:
      type: object
      properties:
        rows:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                description: memberID
              name:
                type: string
                description: 客戶名稱
              email:
                type: string
                description: mail
              phone:
                type: string
                description: 電話
        allPages:
          type: integer
          description: 總頁數
        page:
          type: integer
          description: 目前頁數
        limit:
          type: integer
          description: 一頁幾筆
        total:
          type: integer
    Login:
      type: object
      properties:
        account:
          type: string
          description: email帳號
        pwd:
          type: string
        company:
          type: string
          description: 統一編號
    GetRebatePagination:
      type: object
      properties:
        rows:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                description: rebateID
              accType:
                type: string
              rDate:
                type: string
                description: 日期
              amount:
                type: integer
                description: 折讓金額
              taxType:
                type: string
              taxAmount:
                type: integer
        allPages:
          type: integer
          description: 總頁數
        page:
          type: integer
          description: 目前頁數
        limit:
          type: integer
          description: 一頁幾筆
        total:
          type: integer
    GetRebateDetail:
      type: object
      properties:
        id:
          type: string
        budgetId:
          type: string
        accType:
          type: string
        rDate:
          type: string
        amount:
          type: integer
        tax:
          type: object
          properties:
            type:
              type: string
            amount:
              type: integer
            rate:
              type: integer
        debitAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTermWithId'
        creditAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTermWithId'    
    GetTransferPagination:
      type: object
      properties:
        rows:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                description: transferID
              budget:
                type: string
                description: 預算名稱
              date:
                type: string
                description: 轉帳日期
              desc:
                type: string
                description: 摘要
              amount:
                type: string
                description: 金額
        allPages:
          type: integer
          description: 總頁數
        page:
          type: integer
          description: 目前頁數
        limit:
          type: integer
          description: 一頁幾筆
        total:
          type: integer
    PutTransfer:
      type: object
      properties:
        id:
          type: string
        budgetId:
          type: string
          description: 預算ID
        tDate:
          type: string
          description: 日期
        summary:
          type: string
          description: 摘要
        debitAccTerm:
          type: array
          items:
            $ref: '#/components/schemas/AccTermWithId'
        creditAccTerm:
          type: array
          items:
            $ref: '#/components/schemas/AccTermWithId'
        deleteAccterm:
          type: array
          items:
            type: string
    Modifymember:
      type: object
      properties:
        id:
          type: string
        mType:
          type: string
          enum: [enterprise, person]
        mid:
          type: string
          description: 身份證字號 (統一編號)
        name:
          type: string
          description: 名字 (公司名稱)
        sex:
          type: integer
          enum: [0,1]
          description: 性別
        birthday:
          type: string
        email:
          type: string
        address:
          type: string
        serviceUnit:
          type: string
          description: 服務單位
        contact:
          type: array
          items:
            type: object
            properties:
              ctType:
                type: string
                enum: ["home", "office", "mobile"]
              value:
                type: string
    Postmember:
      type: object
      properties:
        mType:
          type: string
          enum: [enterprise, person]
        mid:
          type: string
          description: 身份證字號 (統一編號)
        name:
          type: string
          description: 名字 (公司名稱)
        sex:
          type: integer
          enum: [0,1]
          description: 性別
        birthday:
          type: string
        email:
          type: string
        address:
          type: string
        serviceUnit:
          type: string
          description: 服務單位
        contact:
          type: array
          items:
            type: object
            properties:
              ctType:
                type: string
                enum: ["home", "office", "mobile"]
              value:
                type: string
        account:
          type: object
          properties:
            payDate:
              type: string
              description: 日期
            joinFee:
              type: integer
              description: 入會費
            annualFee:
              type: integer
              description: 常年會費
            method:
              type: string
              description: 付款方式
            desc:
              type: string
              description: 摘要
    TransferDetail:
      type: object
      properties:
        id:
          type: string
        budgetId:
          type: string
          description: 預算ID
        tDate:
          type: string
          description: 日期
        summary:
          type: string
          description: 摘要
        debitAccTerm:
          type: array
          items:
            $ref: '#/components/schemas/AccTermWithId'
        creditAccTerm:
          type: array
          items:
            $ref: '#/components/schemas/AccTermWithId'
    PostRebate:
      type: object
      properties:
        accType:
          type: string
          enum: ["income","expenses"]
          description: 折讓類別(收入、支出)
        rDate:
          type: string
          description: 日期
        amount:
          type: integer
          description: 折讓金額
        receiptId:
          type: string
          description: 憑證ID(無憑證折讓帶空字串)
        tax:
          type: object
          properties:
            type:
              type: string
              description: 稅別類型(應稅、免稅、零稅、無法抵扣)
              enum: ["tax", "free", "zero", "none"]
            amount:
              type: integer
              description: 稅額
        debitAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
        creditAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
    PutRebate:
      type: object
      properties:
        id:
          type: string
        accType:
          type: string
          enum: ["income","expenses"]
          description: 折讓類別(收入、支出)
        rDate:
          type: string
          description: 日期
        amount:
          type: integer
          description: 折讓金額
        receiptId:
          type: string
          description: 憑證ID(無憑證折讓帶空字串)
        tax:
          type: object
          properties:
            type:
              type: string
              description: 稅別類型(應稅、免稅、零稅、無法抵扣)
              enum: ["tax", "free", "zero", "none"]
            amount:
              type: integer
              description: 稅額
        debitAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
        creditAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
        delDebitAccTermList:
          type: array
          items:
            type: string
        delCreditAccTermList:
          type: array
          items:
            type: string
    PostTransfer:
      type: object
      properties:
        budgetId:
          type: string
          description: 預算ID
        tDate:
          type: string
          description: 日期
        summary:
          type: string
          description: 摘要
        debitAccTerm:
          $ref: '#/components/schemas/AccTerm'
        creditAccTerm:
          $ref: '#/components/schemas/AccTerm'
    ReceiptDetail:
      type: object
      properties:
        id:
          type: string
        budgetId:
          type: string
        accType:
          type: string
          enum: ["income","expenses"]
          description: 發票類別(收入、支出)
        rDate:
          type: string
          description: 發票日期
        type:
          type: string
          enum: ["electronic", "triplicate", "duplicate"]
          description: 發票類別(電子發票、二聯、三聯)
        number:
          type: string
          description: 發票號碼
        VATnumber:
          type: string
          description: 統一編號
        amount:
          type: integer
          description: 金額
        isCollect:
          type: boolean
          description: 是否匯總
        collectQuantity:
          type: integer
          description: 匯總數量
        isFixedAsset:
          type: boolean
          description: 是否為固定資產
        tax:
          type: object
          properties:
            type:
              type: string
              description: 稅別類型(應稅、免稅、零稅、無法抵扣)
              enum: ["tax", "free", "zero", "none"]
            amount:
              type: integer
              description: 稅額
            rate:
              type: integer
              description: 稅率
        pictures:
          type: array
          items:
            type: object
            properties:
              origin:
                type: string
              thumb:
                type: string
        debitAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
        creditAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
    PutReceiptDetail:
      type: object
      properties:
        id:
          type: string
        budgetId:
          type: string
        accType:
          type: string
          enum: ["income","expenses"]
          description: 發票類別(收入、支出)
        rDate:
          type: string
          description: 發票日期
        type:
          type: string
          enum: ["electronic", "triplicate", "duplicate"]
          description: 發票類別(電子發票、二聯、三聯)
        number:
          type: string
          description: 發票號碼
        VATnumber:
          type: string
          description: 統一編號
        amount:
          type: integer
          description: 金額
        isCollect:
          type: boolean
          description: 是否匯總
        collectQuantity:
          type: integer
          description: 匯總數量
        isFixedAsset:
          type: boolean
          description: 是否為固定資產
        tax:
          type: object
          properties:
            type:
              type: string
              description: 稅別類型(應稅、免稅、零稅、無法抵扣)
              enum: ["tax", "free", "zero", "none"]
            amount:
              type: integer
              description: 稅額
            rate:
              type: integer
              description: 稅率
        pictures:
          type: array
          items:
            type: string
        debitAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
        creditAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
        delDebitAccTermList:
          type: array
          items:
            type: string
        delCreditAccTermList:
          type: array
          items:
            type: string
        delPictures:
          type: array
          items:
            type: string
    PostReceipt:
      type: object
      properties:
        budgetId:
          type: string
        accType:
          type: string
          enum: ["income","expenses"]
          description: 發票類別(收入、支出)
        rDate:
          type: string
          description: 發票日期
        type:
          type: string
          enum: ["electronic", "triplicate", "duplicate"]
          description: 發票類別(電子發票、二聯、三聯)
        number:
          type: string
          description: 發票號碼
        VATnumber:
          type: string
          description: 統一編號
        amount:
          type: integer
          description: 金額
        isCollect:
          type: boolean
          description: 是否匯總
        collectQuantity:
          type: integer
          description: 匯總數量
        isFixedAsset:
          type: boolean
          description: 是否為固定資產
        tax:
          type: object
          properties:
            type:
              type: string
              description: 稅別類型(應稅、免稅、零稅、無法抵扣)
              enum: ["tax", "free", "zero", "none"]
            amount:
              type: integer
              description: 稅額
        pictures:
          type: array
          items:
            type: string
        debitAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
        creditAccTermList:
          type: array
          items:
            $ref: '#/components/schemas/AccTerm'
    GetReceiptPagination:
      type: object
      properties:
        rows:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                description: receiptID
              accType:
                type: string
                enum: ["income","expenses"]
                description: 發票類別(收入、支出)
              date:
                type: string
                description: 發票日期
              number:
                type: string
                description: 發票號碼
              VATnumber:
                type: string
                description: 統一編號
              amount:
                type: integer
                description: 金額
              type:
                type: string
                description: 發票類型
        allPages:
          type: integer
          description: 總頁數
        page:
          type: integer
          description: 目前頁數
        limit:
          type: integer
          description: 一頁幾筆
        total:
          type: integer
    AccTermWithId:
      type: object
      properties:
        id:
          type: string
        code:
          type: string
        name:
          type: string
        amount:
          type: integer
        desc:
          type: string
    AccTerm:
      type: object
      properties:
        code:
          type: string
        name:
          type: string
        amount:
          type: integer
        desc:
          type: string
    AccTermItem:
      type: object
      properties:
        code:
          type: string
        name:
          type: string
    GetAccTermList:
      type: array
      items:
        $ref: '#/components/schemas/AccTermItem'
    BudgetItem:
      type: object
      properties:
        code:
          type: string
        name:
          type: string
        amount:
          type: integer
        desc:
          type: string
    ModifyBudget:
      type: object
      properties:
        id:
          type: string
        year:
          type: integer
        title:
          type: string
        amount:
          type: integer
        startDate:
          type: string
          example: "2018-03-01T00:00:00+08:00"
        endDate:
          type: string
          example: "2018-05-01T00:00:00+08:00"
        income:
          type: array
          items:
            $ref: '#/components/schemas/BudgetItem'
        expenses:
          type: array
          items:
            $ref: '#/components/schemas/BudgetItem'
        parentId:
          type: string
        project:
          type: array
          items:
            type: string
          description: 專案清單
        delProject:
          type: array
          items:
            type: string
          description: 專案清單
    BudgetDetail:
      type: object
      properties:
        id:
          type: string
        year:
          type: integer
        title:
          type: string
        amount:
          type: integer
          description: 預算總額
        parentId:
          type: string
        startDate:
          type: string
          example: "2018-03-01T00:00:00+08:00"
        endDate:
          type: string
          example: "2018-05-01T00:00:00+08:00"
        income:
          type: array
          items:
            $ref: '#/components/schemas/BudgetItem'
        expenses:
          type: array
          items:
            $ref: '#/components/schemas/BudgetItem'
        createTime:
          type: string
        creator:
          type: string
    PostBudget:
      type: object
      properties:
        year:
          type: integer
        title:
          type: string
        type:
          type: string
          enum: [project, year]
        amount:
          type: integer
          description: 預算總額
        startDate:
          type: string
          example: "2018-03-01T00:00:00+08:00"
        endDate:
          type: string
          example: "2018-05-01T00:00:00+08:00"
        income:
          type: array
          items:
            $ref: '#/components/schemas/BudgetItem'
        expenses:
          type: array
          items:
            $ref: '#/components/schemas/BudgetItem'
        parentId:
          type: string
        project:
          type: array
          items:
            type: string
          description: 專案清單
    GetBudget:
      type: array
      items:
        type: object
        properties:
          id:
            type: string
          year:
            type: integer
          title:
            type: string
          income:
            type: integer
          expenses:
            type: integer
          total:
            type: integer
          projectCount:
            type: integer
          startDate:
            type: string
            example: "2018-03-01T00:00:00+08:00"
          endDate:
            type: string
            example: "2018-05-01T00:00:00+08:00"
          createTime:
            type: string
          creator:
            type: string
  securitySchemes:
    ApiKeyAuth:        # arbitrary name for the security scheme
      type: apiKey
      in: header       # can be "header", "query" or "cookie"
      name: Auth-Token  # name of the header, query parameter or cookie